import os
import collections
from abc import ABCMeta, abstractmethod
from xml.etree import ElementTree
from xml.dom import minidom

unit_bohr_angstrom = float(0.52917720859)
unit_hartree_ev = float(27.2114)
#unit_hartree_ev = float(27.2113845) # abinit

class Calculator:
    __metaclass__ = ABCMeta
    ppdir=None
    pplist=None
    bindir = None
    cmd=None
    scenaeio=None
    pp=None
    mpi_cmd=None
    nproc=1

    matid=None
    chemical_formula=None
    cry_system=None
    spg_name=None
    spg_num=None
    cell_a=0.0
    cell_b=0.0
    cell_c=0.0
    cell_alpha=0.0
    cell_beta=0.0
    cell_gamma=0.0

    #primcell=None
    #convcell=None
    cell=None
    cell0=None
    cell1=None
    atom=None
    atom0=None
    atom1=None
    rcell=None
    nele=0
    natom=0
    ele=None
    natom_ele=None

    bravais_center=None
    bravais_subtype=None

    kpath=None
    spin=1
    nbands=0
    nelect=0
    nkp=[1,1,1]
    emin=0.0
    emax=0.0
    nkp_max=None

    def __init__(self):
        # parameters
        self.calc = collections.OrderedDict()
        self.input = {};
        self.pp = collections.OrderedDict()

    #@abstractmethod
    def calc(self):
        print("calculator calc...")

    #@abstractmethod
    def potentials(self,ele):
        print("calculator potentials...")

    #@abstractmethod
    def inputs(self,task):
        print("calculator inputs...")

    #@abstractmethod
    def nbands(self,ele,atom):
        print("calculator nbands...")

    #@abstractmethod
    def structure(self,name, d):
        print("calculator structure...")

    #@abstractmethod
    def mag(self, d):
        print("calculator mag...")

    #@abstractmethod
    def efermi(self, d):
        print("calculator efermi...")
        
    #@abstractmethod
    def results(self,task,f):
        print("calculator results...")
        
