import os
import numpy
import math
from operator import itemgetter              
from xml.etree import ElementTree
from xml.dom import minidom

def cellparameter(root):
    print("[cell parameter]")
    #doc = ElementTree.parse("calculations.xml")
    #root = doc.getroot()

    primcell = []
    convcell = []
    atom_conv = []
    atom_prim = []
    pcell = []
    atom = []
    for e0 in root.findall("structure"):
        if e0.attrib.get("name") == "original":
            for e1 in e0.findall("lattice"):
                if e1.attrib.get("type") == "conventional":
                    for e2 in e1.findall("a1"):
                        l0 = e2.text.split()
                        convcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a2"):
                        l0 = e2.text.split()
                        convcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a3"):
                        l0 = e2.text.split()
                        convcell.append([l0[0],l0[1],l0[2]])
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("a1"):
                        l0 = e2.text.split()
                        primcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a2"):
                        l0 = e2.text.split()
                        primcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a3"):
                        l0 = e2.text.split()
                        primcell.append([l0[0],l0[1],l0[2]])
            for e1 in e0.findall("atom"):
                if e1.attrib.get("type") == "conventional":
                    for e2 in e1.findall("i"):                            
                        l0 = e2.attrib.get("name")
                        l1 = e2.text.split()
                        l2 = e2.attrib.get("site")
                        l3 = e2.attrib.get("operation")
                        atom_conv.append([l0,l1[0],l1[1],l1[2],l2,l3])
            for e1 in e0.findall("atom"):
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("i"):                            
                        l0 = e2.attrib.get("name")
                        l1 = e2.text.split()
                        l2 = e2.attrib.get("site")
                        l3 = e2.attrib.get("operation")
                        atom_prim.append([l0,l1[0],l1[1],l1[2],l2,l3])

    for e0 in root.findall("calculation"):
        #if e0.attrib.get("name") == "scf":
        if e0.attrib.get("name") == "scf" or e0.attrib.get("dir") == ".":
            for e1 in e0.findall("structure"):
                if e1.attrib.get("name") == "initial":
                    for e2 in e1.findall("lattice"):
                        if e2.attrib.get("type") == "primitive":
                            for e3 in e2.findall("a1"):
                                l0 = e3.text.split()
                                pcell.append([l0[0],l0[1],l0[2]])
                            for e3 in e2.findall("a2"):
                                l0 = e3.text.split()
                                pcell.append([l0[0],l0[1],l0[2]])
                            for e3 in e2.findall("a3"):
                                l0 = e3.text.split()
                                pcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("atom"):
                        for e3 in e2.findall("i"):                            
                            l0 = e3.attrib.get("name")
                            l1 = e3.text.split()
                            atom.append([l0,l1[0],l1[1],l1[2]])
                            
    #print(primcell)
    #print(convcell)
    print(pcell)
    print(atom)
    convcell = numpy.array(convcell,float)
    primcell = numpy.array(primcell,float)
    prim2conv = numpy.dot(primcell,numpy.linalg.inv(convcell))
    conv2prim = numpy.dot(convcell,numpy.linalg.inv(primcell))
    pcell = numpy.array(pcell,float)
    #ccell = numpy.dot(pcell,conv2prim)
    ccell = numpy.dot(conv2prim,pcell)
    #print(prim2conv)
    #print(conv2prim)
    print("convcell:",ccell)
    a = ccell[0]
    b = ccell[1]
    c = ccell[2]
    la = numpy.sqrt(numpy.dot(a,a))
    lb = numpy.sqrt(numpy.dot(b,b))
    lc = numpy.sqrt(numpy.dot(c,c))
    #aa = math.acos(numpy.dot(b,c)/(lb*lc)) * 180.0 / math.pi
    #ab = math.acos(numpy.dot(c,a)/(lc*la)) * 180.0 / math.pi
    #ac = math.acos(numpy.dot(a,b)/(la*lc)) * 180.0 / math.pi
    aa = math.degrees(math.acos(numpy.dot(b,c)/(lb*lc)))
    ab = math.degrees(math.acos(numpy.dot(c,a)/(lc*la)))
    ac = math.degrees(math.acos(numpy.dot(a,b)/(la*lb)))
    print("lattice parameter:",la,lb,lc,aa,ab,ac)

    a = pcell[0]
    b = pcell[1]
    c = pcell[2]
    d = numpy.cross(b,c)
    vol = numpy.dot(a,d)
    rcell = numpy.zeros((3,3))
    d = numpy.cross(b,c)
    rcell[0] = d / vol
    d = numpy.cross(c,a)
    rcell[1] = d / vol
    d = numpy.cross(a,b)
    rcell[2] = d / vol
    print("primcell:",pcell)
    print("recipcell:",rcell)

    #for i,a in enumerate(atom_conv):
    #    a0 = numpy.array([a[1],a[2],a[3]],float)
    #    a1 = numpy.dot(conv2prim,a0)
    #    print(a0,a1)

    # update parameter
    for e0 in root.findall("structure"):
        if e0.attrib.get("name") == "relaxed":
            # conventional cell
            e1 = ElementTree.SubElement(e0,"lattice")
            e1.set("type","conventional")
            e2 = ElementTree.SubElement(e1,"a")
            e2.text = str(la)
            e2 = ElementTree.SubElement(e1,"b")
            e2.text = str(lb)
            e2 = ElementTree.SubElement(e1,"c")
            e2.text = str(lc)
            e2 = ElementTree.SubElement(e1,"alpha")
            e2.text = str(aa)
            e2 = ElementTree.SubElement(e1,"beta")
            e2.text = str(ab)
            e2 = ElementTree.SubElement(e1,"gamma")
            e2.text = str(ac)

            e1 = ElementTree.SubElement(e0,"lattice")
            e1.set("type","conventional")
            e2 = ElementTree.SubElement(e1,"a1")
            e2.text = str(ccell[0][0])+" "+str(ccell[0][1])+" "+str(ccell[0][2])
            e2 = ElementTree.SubElement(e1,"a2")
            e2.text = str(ccell[1][0])+" "+str(ccell[1][1])+" "+str(ccell[1][2])
            e2 = ElementTree.SubElement(e1,"a3")
            e2.text = str(ccell[2][0])+" "+str(ccell[2][1])+" "+str(ccell[2][2])
                    
            # primitive cell
            e1 = ElementTree.SubElement(e0,"lattice")
            e1.set("type","primitive")
            e2 = ElementTree.SubElement(e1,"a1")
            e2.text = str(pcell[0][0])+" "+str(pcell[0][1])+" "+str(pcell[0][2])
            e2 = ElementTree.SubElement(e1,"a2")
            e2.text = str(pcell[1][0])+" "+str(pcell[1][1])+" "+str(pcell[1][2])
            e2 = ElementTree.SubElement(e1,"a3")
            e2.text = str(pcell[2][0])+" "+str(pcell[2][1])+" "+str(pcell[2][2])

            # atom
            e1 = ElementTree.SubElement(e0,"atom")
            e1.set("type","primitive")
            for i,a in enumerate(atom):
                e2 = ElementTree.SubElement(e1,"i")
                e2.set("name",a[0])
                if atom_prim[i][4] is not None:                    
                    e2.set("site",atom_prim[i][4])
                if atom_prim[i][5] is not None:
                    e2.set("operation",atom_prim[i][5])
                e2.text = a[1]+" "+a[2]+" "+a[3]

            # reciprocal cell
            e1 = ElementTree.SubElement(e0,"lattice")
            e1.set("type","reciprocal")
            e2 = ElementTree.SubElement(e1,"a1")
            e2.text = str(rcell[0][0])+" "+str(rcell[0][1])+" "+str(rcell[0][2])
            e2 = ElementTree.SubElement(e1,"a2")
            e2.text = str(rcell[1][0])+" "+str(rcell[1][1])+" "+str(rcell[1][2])
            e2 = ElementTree.SubElement(e1,"a3")
            e2.text = str(rcell[2][0])+" "+str(rcell[2][1])+" "+str(rcell[2][2])

    ##tree = ElementTree.tostring(root,'utf-8')
    ##f0 = open("calculations.xml","w")
    ###minidom.parseString(tree).writexml(f0,indent='',addindent='  ',newl='\n',encoding="utf-8")
    ##minidom.parseString(tree).writexml(f0)
    ##f0.close()

def bandgap(root):
    print("[bandgap]")
    #doc = ElementTree.parse("calculations.xml")
    #root = doc.getroot()

    ispin = None
    nbands = None
    nkpoints = None
    nelect = None
    efermi = None
    kp = []  # kx,ky,kz
    ke = []  # spin,kp,band,[ene,occ]
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "dos" or e0.attrib.get("name") == "nscf":
            for e1 in e0.findall("parameters/i"):
                if e1.attrib.get("name") == "ispin":
                    ispin = int(e1.text)
                if e1.attrib.get("name") == "nbands":
                    nbands = int(e1.text)
                if e1.attrib.get("name") == "nkpoints":
                    nkpoints = int(e1.text)
                if e1.attrib.get("name") == "nelect":
                    nelect = float(e1.text)
            for e1 in e0.findall("parameters/kpoints/i"):
                l = e1.text.split()
                kp.append([float(l[0]),float(l[1]),float(l[2])])
            for e1 in e0.findall("properties/band/spin"):
                if e1.attrib.get("spin") == "1":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[0].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[0][i].append([float(l[0]),float(l[1])])
                if e1.attrib.get("spin") == "2":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[1].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[1][i].append([float(l[0]),float(l[1])])
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi = float(e1.text)

    primcell = []
    convcell = []
    for e0 in root.findall("structure"):
        if e0.attrib.get("name") == "original":
            for e1 in e0.findall("lattice"):
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("a1"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a2"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a3"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                if e1.attrib.get("type") == "conventional":
                    for e2 in e1.findall("a1"):
                        l = e2.text.split()
                        convcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a2"):
                        l = e2.text.split()
                        convcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a3"):
                        l = e2.text.split()
                        convcell.append([float(l[0]),float(l[1]),float(l[2])])

    # abinit
    if efermi is None:
        for e0 in root.findall("calculation[@name='scf']/properties/i[@name='efermi']"):
            efermi = float(e0.text)

    #print("ispin",ispin)
    #print("nbands",nbands)
    #print("nkpoints",nkpoints)
    #print("nelect",nelect)
    print("efermi",efermi)

    primcell = numpy.array(primcell,float)
    convcell = numpy.array(convcell,float)
    prim2conv = numpy.dot(primcell,numpy.linalg.inv(convcell))
    conv2prim = numpy.dot(convcell,numpy.linalg.inv(primcell))
    #print(primcell)
    #print(convcell)
    #print(prim2conv)
    #print(conv2prim)
    #print(conv2prim.T)

    for i in range(len(kp)):
        #print(i,kp[i][0],kp[i][1],kp[i][2])
        pass

    for i in range(len(ke)):
        for j in range(len(ke[i])):
            for k in range(len(ke[i][j])):
                print(i,j,k,ke[i][j][k][0],ke[i][j][k][1])
                #pass

    bandgap_type = None
    bandgap = None
    valence_band = None
    conduction_band = None
    valence_band_up = None
    conduction_band_up = None
    valence_band_dn = None
    conduction_band_dn = None

    if ispin == 1:
        if nelect % 2 == 1:
            bandgap_type = "metal"
        else:
            nb = int(nelect / 2)
            band_max = []  # band,[spin,kp,band,eval]
            band_min = []  # band,[spin,kp,band,eval]
            for j in range(nbands):
                band = []  # kp,[spin,kp,band,eval]
                for k in range(nkpoints):
                    band.append([ispin,k,j,ke[0][k][j][0]])
                band = sorted(band,key=itemgetter(3),reverse=True)
                band_max.append(band[0])
                band_min.append(band[nkpoints-1])

            band_vb = band_max[nb-1]
            band_cb = band_min[nb]
            #print("vb",band_vb)
            #print("cb",band_cb)

            #print(band_vb[3],band_cb[3],band_cb[3]-band_vb[3])
            #print(band_vb[3],band_vb[1],kp[int(band_vb[1])])
            #print(band_cb[3],band_cb[1],kp[int(band_cb[1])])

            # prim -> conv in recip space
            k = numpy.array(kp[int(band_vb[1])])
            kp_vb = numpy.dot(conv2prim.T,k)
            #print(band_vb[3],band_vb[1],numpy.dot(conv2prim.T,k))
            k = numpy.array(kp[int(band_cb[1])])
            kp_cb = numpy.dot(conv2prim.T,k)
            #print(band_cb[3],band_cb[1],numpy.dot(conv2prim.T,k))

            print("valence_band:",band_vb[3],"kp:",int(band_vb[1]),kp_vb)
            print("conduction_band:",band_cb[3],"kp:",int(band_cb[1]),kp_cb)

            if band_cb[3] > band_vb[3]:
                bandgap = band_cb[3]-band_vb[3]
                if band_cb[1] == band_vb[1]:  # XXX fixed 2018-07-10
                    bandgap_type = "direct"
                else:
                    bandgap_type = "indirect"
                valence_band = band_vb
                conduction_band = band_cb
            else:
                bandgap_type = "metal"

    elif ispin == 2:
        nb = int(nelect / 2)
        band_max = []  # band,[spin,kp,band,eval]
        band_min = []  # band,[spin,kp,band,eval]
        band_max_up = []
        band_min_up = []
        band_max_dn = []
        band_min_dn = []
        for i in range(ispin):
            for j in range(nbands):
                band = []  # kp,[spin,kp,band,eval]
                for k in range(nkpoints):
                    band.append([i,k,j,ke[i][k][j][0]])
                band = sorted(band,key=itemgetter(3),reverse=True)
                band_max.append(band[0])
                band_min.append(band[nkpoints-1])
                if i==0:
                    band_max_up.append(band[0])
                    band_min_up.append(band[nkpoints-1])
                elif i==1:
                    band_max_dn.append(band[0])
                    band_min_dn.append(band[nkpoints-1])

        band_max = sorted(band_max,key=itemgetter(3))
        band_min = sorted(band_min,key=itemgetter(3))
        #print(band_max)
        #print(band_min)

        band_vb = band_max[int(nelect)-1]
        band_cb = band_min[int(nelect)]
        #print(band_vb)
        #print(band_cb)

        k = numpy.array(kp[int(band_vb[1])])
        kp_vb = numpy.dot(conv2prim.T,k)
        #print(band_vb[3],band_vb[1],numpy.dot(conv2prim.T,k))
        k = numpy.array(kp[int(band_cb[1])])
        kp_cb = numpy.dot(conv2prim.T,k)
        #print(band_cb[3],band_cb[1],numpy.dot(conv2prim.T,k))

        print("valence_band:",band_vb[3],"kp:",int(band_vb[1]),kp_vb)
        print("conduction_band:",band_cb[3],"kp:",int(band_cb[1]),kp_cb)

        if band_cb[3] > band_vb[3]:
            bandgap = band_cb[3] - band_vb[3]
            if band_vb[1] == band_cb[1]:
                bandgap_type = "direct"
            else:
                bandgap_type = "indirect"
            valence_band = band_vb
            conduction_band = band_cb
        else:
            bandgap_type = "metal"

        # half metal
        gap = [0.0,0.0]
        tmin = [0.0,0.0]
        tmax = [0.0,0.0]
        for l in range(nbands-1):
            if band_max_up[l][3] < efermi and efermi < band_min_up[l+1][3]:
                band_vb_up = band_max_up[l]
                band_cb_up = band_min_up[l+1]

                gap[0] = band_cb_up[3] - band_vb_up[3];
                tmin[0] = band_cb_up[3];
                tmax[0] = band_vb_up[3];

                k = numpy.array(kp[int(band_vb_up[1])])
                kp_vb_up = numpy.dot(conv2prim.T,k)
                k = numpy.array(kp[int(band_cb_up[1])])
                kp_cb_up = numpy.dot(conv2prim.T,k)
                print("  bandgap_up",gap[0])
                print("  bandgap_vb_kp",band_vb_up[1],kp_vb_up)
                print("  bandgap_cb_kp",band_cb_up[1],kp_cb_up)

                valence_band_up = band_vb_up
                conduction_band_up = band_cb_up

            if band_max_dn[l][3] < efermi and efermi < band_min_dn[l+1][3]:
                band_vb_dn = band_max_dn[l]
                band_cb_dn = band_min_dn[l+1]

                gap[1] = band_cb_dn[3] - band_vb_dn[3];
                tmin[1] = band_cb_dn[3];
                tmax[1] = band_vb_dn[3];

                k = numpy.array(kp[int(band_vb_dn[1])])
                kp_vb_dn = numpy.dot(conv2prim.T,k)
                k = numpy.array(kp[int(band_cb_dn[1])])
                kp_cb_dn = numpy.dot(conv2prim.T,k)
                print("  bandgap_down",gap[1])
                print("  bandgap_vb_kp",band_vb_dn[1],kp_vb_dn)
                print("  bandgap_cb_kp",band_cb_dn[1],kp_cb_dn)

                valence_band_dn = band_vb_dn
                conduction_band_dn = band_cb_dn

        if gap[0] != 0 and gap[1] != 0:
            tmax = sorted(tmax,reverse=True)
            tmin = sorted(tmin,reverse=True)
            tgap = tmin[0] - tmax[0];
            print("  bandgap_total",tgap)

    print("bandgap_type:",bandgap_type)
    print("bandgap:",bandgap)

    # update parameter
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "dos" or e0.attrib.get("name") == "nscf":
            for e1 in e0.findall("properties"):
                if bandgap_type != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","bandgap_type")
                    e2.text = bandgap_type
                if bandgap != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","bandgap")
                    e2.set("unit","eV")
                    e2.text = str(bandgap)
                if valence_band != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","valence_band")
                    e2.set("kpoint",str(valence_band[1]+1))
                    e2.set("band",str(valence_band[2]+1))
                    e2.set("unit","eV")
                    k0 = numpy.array(kp[int(valence_band[1])])
                    k = numpy.dot(conv2prim.T,k0)
                    e2.text = str(valence_band[3])+" "+str(k[0])+" "+str(k[1])+" "+str(k[2])
                if conduction_band != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","conduction_band")
                    e2.set("kpoint",str(conduction_band[1]+1))
                    e2.set("band",str(conduction_band[2]+1))
                    e2.set("unit","eV")
                    k0 = numpy.array(kp[int(conduction_band[1])])
                    k = numpy.dot(conv2prim.T,k0)
                    e2.text = str(conduction_band[3])+" "+str(k[0])+" "+str(k[1])+" "+str(k[2])
                if valence_band_up != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","valence_band")
                    e2.set("spin","1")
                    e2.set("kpoint",str(valence_band_up[1]+1))
                    e2.set("band",str(valence_band_up[2]+1))
                    e2.set("unit","eV")
                    k0 = numpy.array(kp[int(valence_band_up[1])])
                    k = numpy.dot(conv2prim.T,k0)
                    e2.text = str(valence_band_up[3])+" "+str(k[0])+" "+str(k[1])+" "+str(k[2])
                if conduction_band_up != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","conduction_band")
                    e2.set("spin","1")
                    e2.set("kpoint",str(conduction_band_up[1]+1))
                    e2.set("band",str(conduction_band_up[2]+1))
                    e2.set("unit","eV")
                    k0 = numpy.array(kp[int(conduction_band_up[1])])
                    k = numpy.dot(conv2prim.T,k0)
                    e2.text = str(conduction_band_up[3])+" "+str(k[0])+" "+str(k[1])+" "+str(k[2])
                if valence_band_dn != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","valence_band")
                    e2.set("spin","2")
                    e2.set("kpoint",str(valence_band_dn[1]+1))
                    e2.set("band",str(valence_band_dn[2]+1))
                    e2.set("unit","eV")
                    k0 = numpy.array(kp[int(valence_band_dn[1])])
                    k = numpy.dot(conv2prim.T,k0)
                    e2.text = str(valence_band_dn[3])+" "+str(k[0])+" "+str(k[1])+" "+str(k[2])
                if conduction_band_up != None:
                    e2 = ElementTree.SubElement(e1,"i")
                    e2.set("name","conduction_band")
                    e2.set("spin","2")
                    e2.set("kpoint",str(conduction_band_dn[1]+1))
                    e2.set("band",str(conduction_band_dn[2]+1))
                    e2.set("unit","eV")
                    k0 = numpy.array(kp[int(conduction_band_dn[1])])
                    k = numpy.dot(conv2prim.T,k0)
                    e2.text = str(conduction_band_dn[3])+" "+str(k[0])+" "+str(k[1])+" "+str(k[2])

    ##tree = ElementTree.tostring(root,'utf-8')
    ##f0 = open("calculations.xml","w")
    ###minidom.parseString(tree).writexml(f0,indent='',addindent='  ',newl='\n',encoding="utf-8")
    ##minidom.parseString(tree).writexml(f0)
    ##f0.close()

def effectivemass():
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    b = False
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "emass":
            b = True
    if not b:
        return

    print("[effective mass]")

    ispin = None
    nbands = None
    nkpoints = None
    nelect = None
    efermi = None
    pcell = []
    kp = []  # kx,ky,kz
    ke = []  # spin,kp,band,[ene,occ]
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "emass":
            for e1 in e0.findall("parameters/i"):
                if e1.attrib.get("name") == "ispin":
                    ispin = int(e1.text)
                if e1.attrib.get("name") == "nbands":
                    nbands = int(e1.text)
                if e1.attrib.get("name") == "nkpoints":
                    nkpoints = int(e1.text)
                if e1.attrib.get("name") == "nelect":
                    nelect = float(e1.text)
            for e1 in e0.findall("parameters/kpoints/i"):
                l = e1.text.split()
                kp.append([float(l[0]),float(l[1]),float(l[2])])
            for e1 in e0.findall("properties/band/spin"):
                if e1.attrib.get("spin") == "1":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[0].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[0][i].append([float(l[0]),float(l[1])])
                if e1.attrib.get("spin") == "2":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[1].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[1][i].append([float(l[0]),float(l[1])])
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi = float(e1.text)

    convcell = []
    primcell = []
    for e0 in root.findall("structure"):
        if e0.attrib.get("name") == "relaxed":
            for e1 in e0.findall("lattice"):
                if e1.attrib.get("type") == "conventional":
                    for e2 in e1.findall("a1"):
                        l = e2.text.split()
                        convcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a2"):
                        l = e2.text.split()
                        convcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a3"):
                        l = e2.text.split()
                        convcell.append([float(l[0]),float(l[1]),float(l[2])])
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("a1"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a2"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a3"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])

    #print("ispin",ispin)
    #print("nbands",nbands)
    #print("nkpoints",nkpoints)
    #print("nelect",nelect)
    print("efermi",efermi)

    for i in range(len(kp)):
        #print(i,kp[i][0],kp[i][1],kp[i][2])
        pass

    for i in range(len(ke)):
        for j in range(len(ke[i])):
            for k in range(len(ke[i][j])):
                #print(i,j,k,ke[i][j][k][0],ke[i][j][k][1])
                pass

    convcell = numpy.array(convcell,float)
    primcell = numpy.array(primcell,float)
    print("convcell",convcell)
    print("primcell",primcell)

    a = primcell[0]
    b = primcell[1]
    c = primcell[2]
    d = numpy.cross(b,c)
    vol = numpy.dot(a,d)
    recipcell = numpy.zeros((3,3))
    d = numpy.cross(b,c)
    recipcell[0] = d / vol
    d = numpy.cross(c,a)
    recipcell[1] = d / vol
    d = numpy.cross(a,b)
    recipcell[2] = d / vol
    print("recipcell",recipcell)

    nb = int(nelect / 2)
    kp0 = []
    for k in kp:
        # recip -> cart
        k0 = numpy.array(k,float)
        #k0 = numpy.dot(recipcell,k0)*2.0*math.pi
        k0 = numpy.dot(recipcell.T,k0)*2.0*math.pi
        kp0.append(k0)

    # eval = f(kx,ky,kz)
    for spin in range(ispin):
        for j in range(2):
            a = []
            b = []
            for i,k in enumerate(kp0):
                # valence band (hole mass)
                # conduction band (electron mass)
                if (spin==0 and j==0 and 0<=i and i<27) \
                        or (spin==0 and j==1 and 27<=i and i<54) \
                        or (spin==1 and j==0 and 54<=i and i<81) \
                        or (spin==1 and j==1 and 81<=i and i<108):
                    a0 = []
                    a0.append(k[0]*k[0])
                    a0.append(k[0]*k[1]*2)
                    a0.append(k[0]*k[2]*2)
                    a0.append(k[1]*k[1])
                    a0.append(k[1]*k[2]*2)
                    a0.append(k[2]*k[2])
                    a0.append(k[0])
                    a0.append(k[1])
                    a0.append(k[2])
                    a0.append(1.0)
                    a.append(a0)
                if (spin==0 and j==0 and 0<=i and i<27):
                    b.append(ke[spin][i][nb-1][0])
                if (spin==0 and j==1 and 27<=i and i<54):
                    b.append(ke[spin][i][nb][0])
                if (spin==1 and j==0 and 54<=i and i<81):
                    b.append(ke[spin][i][nb-1][0])
                if (spin==1 and j==1 and 81<=i and i<108):
                    b.append(ke[spin][i][nb][0])

            a = numpy.array(a,float)
            b = numpy.array(b,float)
            x,res,rank,s = numpy.linalg.lstsq(a,b)

            #print(x,res,rank,s)
            print("x:",x)
            print("res:",res)
            #print("s:",s)

            # temporary
            for i,x0 in enumerate(x):
                if abs(x0) < 1.0e-10:
                    #x[i] = 0.0
                    pass
            # inverse effective mass tensor
            ef = []
            ef.append([x[0],x[1],x[2]])
            ef.append([x[1],x[3],x[4]])
            ef.append([x[2],x[4],x[5]])            
            ef = numpy.array(ef)
            print("ef",ef)
            w,v = numpy.linalg.eigh(ef)
            print("w:",w)
            print("v:",v)
            
            ang2b = 1/0.52917721092
            eV2h = 1/27.21138505
            m_ef = 1.0 / (2.0 * w * eV2h * ang2b**2)
            #print("m_ef:",m_ef)
            l1 = math.sqrt(numpy.dot(convcell[0],convcell[0]))
            l2 = math.sqrt(numpy.dot(convcell[1],convcell[1]))
            l3 = math.sqrt(numpy.dot(convcell[2],convcell[2]))
            if j==0:
                print("hole mass:")
            if j==1:
                print("electron mass:")
            for i in range(3):
                ef0 = numpy.array([v[0][i],v[1][i],v[2][i]])
                #alpha = math.acos(numpy.dot(ef0,convcell[0])/l1) * 180.0/math.pi
                #beta = math.acos(numpy.dot(ef0,convcell[1])/l2) * 180.0/math.pi
                #gamma = math.acos(numpy.dot(ef0,convcell[2])/l3) * 180.0/math.pi
                alpha = math.degrees(math.acos(numpy.dot(ef0,convcell[0])/l1))
                beta = math.degrees(math.acos(numpy.dot(ef0,convcell[1])/l2))
                gamma = math.degrees(math.acos(numpy.dot(ef0,convcell[2])/l3))
                if j==0:
                    print(-m_ef[i],alpha,beta,gamma)
                if j==1:
                    print(m_ef[i],alpha,beta,gamma)

def fermisurf():
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    b = False
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "fermisurf":
            b = True
    if not b:
        return

    print("[fermisurf]")

    ispin = None
    nbands = None
    nkpoints = None
    nelect = None
    efermi = None
    primcell = []
    nkp = []
    kp = []  # kx,ky,kz
    ke = []  # spin,kp,band,[ene,occ]
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "fermisurf":
            for e1 in e0.findall("parameters/i"):
                if e1.attrib.get("name") == "ispin":
                    ispin = int(e1.text)
                if e1.attrib.get("name") == "nbands":
                    nbands = int(e1.text)
                if e1.attrib.get("name") == "nkpoints":
                    nkpoints = int(e1.text)
                if e1.attrib.get("name") == "nelect":
                    nelect = float(e1.text)
            for e1 in e0.findall("kpoints"):
                l = e1.text.split()
                nkp = [int(l[0]),int(l[1]),int(l[2])]
            for e1 in e0.findall("parameters/kpoints/i"):
                l = e1.text.split()
                kp.append([float(l[0]),float(l[1]),float(l[2])])
            for e1 in e0.findall("structure"):
                if e1.attrib.get("name") == "initial":
                    for e2 in e1.findall("lattice"):
                        if e2.attrib.get("type") == "primitive":
                            for e3 in e2.findall("a1"):
                                l0 = e3.text.split()
                                primcell.append([l0[0],l0[1],l0[2]])
                            for e3 in e2.findall("a2"):
                                l0 = e3.text.split()
                                primcell.append([l0[0],l0[1],l0[2]])
                            for e3 in e2.findall("a3"):
                                l0 = e3.text.split()
                                primcell.append([l0[0],l0[1],l0[2]])
            for e1 in e0.findall("properties/band/spin"):
                if e1.attrib.get("spin") == "1":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[0].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[0][i].append([float(l[0]),float(l[1])])
                if e1.attrib.get("spin") == "2":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[1].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[1][i].append([float(l[0]),float(l[1])])
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi = float(e1.text)

    print("ispin",ispin)
    print("nbands",nbands)
    print("nkp",nkp)
    print("nkpoints",nkpoints)
    print("nelect",nelect)
    print("efermi",efermi)

    for i in range(len(kp)):
        #print(i,kp[i][0],kp[i][1],kp[i][2])
        pass

    for i in range(len(ke)):
        for j in range(len(ke[i])):
            for k in range(len(ke[i][j])):
                #print(i,j,k,ke[i][j][k][0],ke[i][j][k][1])
                pass

    primcell = numpy.array(primcell,float)
    print(primcell)
    a = primcell[0]
    b = primcell[1]
    c = primcell[2]
    d = numpy.cross(b,c)
    vol = numpy.dot(a,d)
    recipcell = numpy.zeros((3,3))
    d = numpy.cross(b,c)
    recipcell[0] = d / vol
    d = numpy.cross(c,a)
    recipcell[1] = d / vol
    d = numpy.cross(a,b)
    recipcell[2] = d / vol
    print("recipcell",recipcell)

    band_max = []  # band,[spin,kp,band,eval]
    band_min = []  # band,[spin,kp,band,eval]
    bandef = []
    for i in range(ispin):
        bandef.append([])
        for j in range(nbands):
            band = []  # kp,[spin,kp,band,eval]
            for k in range(nkpoints):
                band.append([i,k,j,ke[i][k][j][0]])
            band = sorted(band,key=itemgetter(3),reverse=True)
            band_max.append(band[0])
            band_min.append(band[nkpoints-1])

            if efermi < band[0][3] and efermi > band[nkpoints-1][3]:
                bandef[-1].append(j)

    print("band",bandef)

    for s in range(ispin):
        ex = numpy.zeros((nkp[0]+1,nkp[1]+1,nkp[2]+1,len(bandef[s])))
        ik = 0
        for k in range(nkp[2]):
            for j in range(nkp[1]):
                for i in range(nkp[0]):
                    for l in range(len(bandef[s])):
                        ex[i][j][k][l] = ke[0][ik][bandef[0][l]][0]
                        #print(i,j,k,ik,bandef[0][l])
                    ik += 1

        for j in range(nkp[1]):
            for i in range(nkp[0]):
                for l in range(len(bandef[s])):
                    ex[i][j][nkp[2]][l] = ex[i][j][0][l]
        for k in range(nkp[2]):
            for j in range(nkp[1]):
                for l in range(len(bandef[s])):
                    ex[nkp[0]][j][k][l] = ex[0][j][k][l]
        for k in range(nkp[2]):
            for i in range(nkp[0]):
                for l in range(len(bandef[s])):
                    ex[i][nkp[1]][k][l] = ex[i][0][k][l]

        # bxsf
        f0 = "fs."+str(s+1)+".bxsf"
        print("file (bxsf):",f0)
        f = open(f0,"w")
        f.write("BEGIN_INFO\n")
        f.write(" Fermi Energy: %f\n" % efermi)
        f.write("END_INFO\n\n")

        f.write("BEGIN_BLOCK_BANDGRID_3D\n")
        f.write(" VASP\n")
        f.write(" BEGIN_BANDGRID_3D\n")
        f.write(" %d \n" % len(bandef[s]))
        f.write(" %d %d %d \n" % (nkp[0]+1,nkp[1]+1,nkp[2]+1))
        f.write(" 0 0 0\n") # origin Gamma

        f.write(" %f %f %f\n" % (2*math.pi*recipcell[0][0],2*math.pi*recipcell[0][1],2*math.pi*recipcell[0][2]))
        f.write(" %f %f %f\n" % (2*math.pi*recipcell[1][0],2*math.pi*recipcell[1][1],2*math.pi*recipcell[1][2]))
        f.write(" %f %f %f\n" % (2*math.pi*recipcell[2][0],2*math.pi*recipcell[2][1],2*math.pi*recipcell[2][2]))

        for l in range(len(bandef[s])):
            f.write(" BAND: %d \n" % (bandef[s][l]+1))
            ik = 0
            for i in range(nkp[0]+1):
                for j in range(nkp[1]+1):
                    for k in range(nkp[2]+1):
                        f.write("%13.5e " % ex[i][j][k][l])
                    f.write("\n")
                if i < nkp[0]:
                    f.write("\n")

        f.write(" END_BANDGRID_3D\n")
        f.write("END_BLOCK_BANDGRID_3D\n")
        f.close()
        
        # cube
        for l in range(len(bandef[s])):
            f0 = "fs."+str(s+1)+"."+str(l+1)+".cube"
            print("file (cube):",f0)
            f = open(f0,"w")
            f.write("fermi energy %f\n" % efermi)
            f.write("\n")
            f.write("1 0.0 0.0 0.0\n")
            f.write("%d %f %f %f\n" % (nkp[0],recipcell[0][0]/nkp[0],recipcell[0][1]/nkp[0],recipcell[0][2]/nkp[0]))
            f.write("%d %f %f %f\n" % (nkp[1],recipcell[1][0]/nkp[1],recipcell[1][1]/nkp[1],recipcell[1][2]/nkp[1]))
            f.write("%d %f %f %f\n" % (nkp[2],recipcell[2][0]/nkp[2],recipcell[2][1]/nkp[2],recipcell[2][2]/nkp[2]))
            f.write("1 0.0 0.0 0.0 0.0\n")

            ik = 0
            for i in range(nkp[0]):
                for j in range(nkp[1]):
                    for k in range(nkp[2]):
                        f.write("%13.5e " % ex[i][j][k][l])
                        ik += 1
                    if ik%6==0:
                        f.write("\n")
            f.close()

def dosplot():
    print("[dos plot]")
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    ispin = None
    dos = []
    efermi = None
    efermi2 = None

    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "dos" or e0.attrib.get("name") == "tdos":
            for e1 in e0.findall("parameters/i"):
                if e1.attrib.get("name") == "ispin":
                    ispin = int(e1.text)
            for e1 in e0.findall("properties/dos/spin"):
                if e1.attrib.get("spin") == "1":
                    dos.append([])
                    for i,e2 in enumerate(e1.findall("i")):
                        l = e2.text.split()
                        dos[0].append([float(l[0]),float(l[1])])
                if e1.attrib.get("spin") == "2":
                    dos.append([])
                    for i,e2 in enumerate(e1.findall("i")):
                        l = e2.text.split()
                        dos[1].append([float(l[0]),float(l[1])])
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi = float(e1.text)
        if e0.attrib.get("name") == "scf":
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi2 = float(e1.text)

    print("ispin",ispin)
    print("efermi",efermi,efermi2)

    f = open("dos.dat","w")
    for i in range(len(dos[0])):
        if ispin == 1:
            e = dos[0][i][0]-efermi2
            #e = dos[0][i][0]
            f.write("%5d %12.6f %12.6f\n" % ((i+1),e,dos[0][i][1]))
        elif ispin == 2:
            e = dos[0][i][0]-efermi2
            f.write("%5d %12.6f %12.6f %12.6f\n" % ((i+1),e,dos[0][i][1],dos[1][i][1]))
    f.close()

    emin = -30
    emax = 20
    l = []
    l.append("set grid\n")
    l.append("set title 'DOS'\n")
    l.append("set xlabel 'Energy (eV)'\n")
    l.append("set ylabel 'Density of State'\n")
    if ispin == 1:
        l.append("plot[:][:] \"dos.dat\" using 2:3 title '' with lines\n")
    if ispin == 2:
        l.append("plot[:][:] \"dos.dat\" using 2:3 title 'spin 1' with lines, \\\n")
        l.append("           \"dos.dat\" using 2:4 title 'spin 2' with lines\n")

    f = open("dos.plt","w")
    for l0 in l:
        f.write(l0)
    f.write("pause -1\n")
    f.close()

    f = open("dos.png.plt","w")
    f.write("set terminal png\n")
    f.write("set output \"dos.png\"\n")
    for l0 in l:
        f.write(l0)
    f.close()
    try:
        os.system("gnuplot dos.png.plt")
    except:
        pass

def pdosplot():
    print("[pdos plot]")
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    ispin = None
    pdos = []
    atom = []
    efermi = None
    efermi2 = None
    pdoscol = []
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "dos" or e0.attrib.get("name") == "pdos":
            for e1 in e0.findall("parameters/i"):
                if e1.attrib.get("name") == "ispin":
                    ispin = int(e1.text)
            #for e1 in e0.findall("properties/pdos/i"):
            #    if e1.attrib.get("name") == "value":
            #        pdoscol = e1.text.split()
            for e1 in e0.findall("properties/pdos/atom"):
                pdos.append([])
                atom.append(e1.attrib.get("name"))

                pdoscol.append([])
                for e2 in e1.findall("i"):
                    if e2.attrib.get("name") == "value":
                        pdoscol[-1] = e2.text.split()

                for e2 in e1.findall("spin"):
                    if e2.attrib.get("spin") == "1":
                        pdos[-1].append([])
                        for i,e3 in enumerate(e2.findall("i")):
                            l0 = e3.text.split()
                            #pdos[-1][0].append(map(float,l0))
                            pdos[-1][0].append(list(map(float,l0)))
                    if e2.attrib.get("spin") == "2":
                        pdos[-1].append([])
                        for i,e3 in enumerate(e2.findall("i")):
                            l0 = e3.text.split()
                            #pdos[-1][1].append(map(float,l0))
                            pdos[-1][1].append(list(map(float,l0)))
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi = float(e1.text)
        if e0.attrib.get("name") == "scf":
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi2 = float(e1.text)

    print("ispin",ispin)
    print("efermi",efermi,efermi2)

    f = open("pdos.dat","w")
    #f.write("# ia is ie ")
    #for i in range(len(pdoscol)):
    #    f.write(pdoscol[i]+" ")
    #f.write("\n")
    for i in range(len(pdos)):

        f.write("# ia is ie ")
        for j in range(len(pdoscol[i])):
            f.write(pdoscol[i][j]+" ")
        f.write("\n")

        for j in range(len(pdos[i])):
            for k in range(len(pdos[i][j])):
                e = pdos[i][j][k][0]-efermi2
                #e = pdos[i][j][k][0]
                f.write("%5d %5d %5d %12.6f " % ((i+1),(j+1),(k+1),e))
                for l in range(len(pdos[i][j][k])-1):
                    f.write("%12.6f " % (pdos[i][j][k][l+1]))
                f.write("\n")
            f.write("\n")
        f.write("\n")
    f.close()

    natom = len(pdos)
    emin = -30
    emax = 20
    l = []
    for k in range(len(pdos)):
        l.append([])
        for j in range(len(pdos[k])):
            l[-1].append([])
            l[-1][-1].append("set grid\n")
            l[-1][-1].append("set title 'PDOS (atom "+str(k+1)+" "+atom[k]+", spin "+str(j+1)+")'\n")
            l[-1][-1].append("set xlabel 'Energy (eV)'\n")
            l[-1][-1].append("set ylabel 'Density of State'\n")
            l[-1][-1].append("plot[:][:] \\\n");
            for i in range(len(pdos[k][j][0])-1):
            #for i in range(len(pdoscol)-1):
                col = "xxx"
                if i+1<len(pdoscol[k]):
                    col = pdoscol[k][i+1]
                l[-1][-1].append("    \"pdos.dat\" using 4:($1=="+str(k+1)+" && $2=="+str(j+1)+"? $"+str(5+i)+":1/0) title '"+col+"' with lines lt "+str(i+1))
                if i < len(pdoscol[k])-2:
                    l[-1][-1].append(", \\")
                    l[-1][-1].append("\n")
            l[-1][-1].append("\n")

    f = open("pdos.plt","w")
    for l0 in l:
        for l1 in l0:
            for l2 in l1:
                f.write(l2)
            f.write("pause -1\n")
    f.close()

    f = open("pdos.png.plt","w")
    f.write("set terminal png\n")
    f.write("set output \"pdos.png\"\n")
    for i in range(len(l)):
        for j in range(len(l[i])):
            f.write("set output \"pdos.a"+str(i+1)+".s"+str(j+1)+".png\"\n")
            for l0 in l[i][j]:
                f.write(l0)
    f.close()
    try:
        os.system("gnuplot pdos.png.plt")
    except:
        pass

def bandplot():
    print("[band plot]")
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    primcell = []
    recipcell = []
    ispin = None
    nbands = None
    nkpoints = None
    nelect = None
    efermi = None
    kp = []  # kx,ky,kz
    ke = []  # spin,kp,band,[ene,occ]
    for e0 in root.findall("structure"):
        if e0.attrib.get("name") == "relaxed":
            for e1 in e0.findall("lattice"):
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("a1"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a2"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a3"):
                        l = e2.text.split()
                        primcell.append([float(l[0]),float(l[1]),float(l[2])])
                if e1.attrib.get("type") == "reciprocal":
                    for e2 in e1.findall("a1"):
                        l = e2.text.split()
                        recipcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a2"):
                        l = e2.text.split()
                        recipcell.append([float(l[0]),float(l[1]),float(l[2])])
                    for e2 in e1.findall("a3"):
                        l = e2.text.split()
                        recipcell.append([float(l[0]),float(l[1]),float(l[2])])
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "band":
            for e1 in e0.findall("parameters/i"):
                if e1.attrib.get("name") == "ispin":
                    ispin = int(e1.text)
                if e1.attrib.get("name") == "nbands":
                    nbands = int(e1.text)
                if e1.attrib.get("name") == "nkpoints":
                    nkpoints = int(e1.text)
                if e1.attrib.get("name") == "nelect":
                    nelect = float(e1.text)
            for e1 in e0.findall("kpoints/i"):
                l = e1.text.split()
                if e1.attrib.get("name"):
                    kp0 = e1.attrib.get("name")
                    kp.append([float(l[0]),float(l[1]),float(l[2]),kp0])
                else:
                    kp.append([float(l[0]),float(l[1]),float(l[2])])
            for e1 in e0.findall("properties/band/spin"):
                if e1.attrib.get("spin") == "1":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[0].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[0][i].append([float(l[0]),float(l[1])])
                if e1.attrib.get("spin") == "2":
                    ke.append([])
                    for i,e2 in enumerate(e1.findall("kpoint")):
                        ke[1].append([])
                        for e3 in e2.findall("i"):
                            l = e3.text.split()
                            ke[1][i].append([float(l[0]),float(l[1])])
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi = float(e1.text)
        if e0.attrib.get("name") == "scf":
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi2 = float(e1.text)

    print("ispin",ispin)
    print("nbands",nbands)
    print("nkpoints",nkpoints)
    print("nelect",nelect)
    print("efermi",efermi,efermi2)

    primcell = numpy.array(primcell,float)
    recipcell = numpy.array(recipcell,float)
    print("primcell",primcell)
    print("recipcell",recipcell)

    kp0 = []
    kp1 = []
    dk = 0.0
    for i,k in enumerate(kp):
        if i==0:
            k0 = numpy.array(kp[i][0:3],float)
            #k0 = numpy.dot(recipcell,k0)
            k0 = numpy.dot(recipcell.T,k0)
        else:
            k0 = numpy.array(kp[i-1][0:3],float)
            #k0 = numpy.dot(recipcell,k0)
            k0 = numpy.dot(recipcell.T,k0)
        k1 = numpy.array(kp[i][0:3],float)
        #k1 = numpy.dot(recipcell,k1)
        k1 = numpy.dot(recipcell.T,k1)
        dk0 = numpy.sqrt(numpy.dot(k1-k0,k1-k0))
        if i>0 and len(kp[i-1])==4 and len(kp[i])==4:
            dk0 = 0.0
        dk = dk + dk0 
        kp0.append(dk)
        if len(k)==4:
            kp1.append([k[3],dk])

    xmin = min(kp0)
    xmax = max(kp0)
    #print(kp1)

    f = open("band.dat","w")
    for j in range(nbands):
        for i in range(nkpoints):
            if ispin == 1:
                e = ke[0][i][j][0]-efermi2
                if len(kp[i])==4:
                    f.write("%5d %5d %12.6f %12.6f %12.6f %12.6f %12.6f %s\n" \
                                % (i+1,j+1,float(kp[i][0]),float(kp[i][1]),float(kp[i][2]),kp0[i],e,kp[i][3]))
                else:
                    f.write("%5d %5d %12.6f %12.6f %12.6f %12.6f %12.6f\n" \
                                % (i+1,j+1,float(kp[i][0]),float(kp[i][1]),float(kp[i][2]),kp0[i],e))
            if ispin == 2:
                e1 = ke[0][i][j][0]-efermi2
                e2 = ke[1][i][j][0]-efermi2
                if len(kp[i])==4:
                    f.write("%5d %5d %12.6f %12.6f %12.6f %12.6f %12.6f %12.6f %s\n" \
                                % (i+1,j+1,float(kp[i][0]),float(kp[i][1]),float(kp[i][2]),kp0[i],e1,e2,kp[i][3]))
                else:
                    f.write("%5d %5d %12.6f %12.6f %12.6f %12.6f %12.6f %12.6f\n" \
                                % (i+1,j+1,float(kp[i][0]),float(kp[i][1]),float(kp[i][2]),kp0[i],e1,e2))

        f.write("\n")
    f.close()

    l = []
    l.append("set grid\n")
    l.append("set title 'Band Structure'\n")
    l.append("set xlabel 'K Points'\n")
    l.append("set ylabel 'Energy (eV)'\n")
    l.append("set xtics (")
    for i,k in enumerate(kp1):
        l.append("\"%s\" %10.5f" % (k[0],k[1]))
        if i<len(kp1)-1:
            l.append(",")
    l.append(")\n")
    if ispin == 1:
        #l.append("plot[:][:] \"band.dat\" using 6:7 title '' with points\n")
        l.append("plot[:][:] \"band.dat\" using 6:7 title '' with lines\n")
    if ispin == 2:
        #l.append("plot[:][:] \"band.dat\" using 6:7 title 'spin 1' with points, \\\n")
        #l.append("           \"band.dat\" using 6:8 title 'spin 2' with points\n")
        l.append("plot[:][:] \"band.dat\" using 6:7 title 'spin 1' with lines, \\\n")
        l.append("           \"band.dat\" using 6:8 title 'spin 2' with lines\n")

    f = open("band.plt","w")
    for l0 in l:
        f.write(l0)
    f.write("pause -1\n")
    f.close()

    f = open("band.png.plt","w")
    f.write("set terminal png\n")
    f.write("set output \"band.png\"\n")
    for l0 in l:
        f.write(l0)
    f.close()
    try:
        os.system("gnuplot band.png.plt")
    except:
        pass

def scplot():
    print("[sc plot]")
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    step = []
    calc = []
    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "opt" \
                or e0.attrib.get("name") == "opt1" or e0.attrib.get("name") == "opt2" \
                or e0.attrib.get("name") == "scf":
            step.append([])
            calc.append(e0.attrib.get("name"))
            for e1 in e0.findall("step/sc"):
                step[-1].append([])
                for e2 in e1.findall("i"):
                    if e2.attrib.get("name")=="etotal":
                        #step[-1][-1].append(float(e2.text))
                        if e2.text.find("******")<0:
                            step[-1][-1].append(float(e2.text))

    print("nstep",len(step),)
    for s in step:
        print(len(s),)
    print

    f = open("scstep.dat","w")
    for i in range(len(step)):
        itr=0
        for j in range(len(step[i])):
            for k in range(len(step[i][j])):
                f.write("%5d %5d %5d %5d %12.6f\n" % ((i+1),(j+1),(k+1),(itr+1),step[i][j][k]))
                itr += 1
            f.write("\n")
    f.close()

    f = open("scstep.plt","w")
    f.write("set grid\n")
    for i in range(len(step)):
        f.write("set title 'SCF Iteration ["+calc[i]+"]'\n")
        f.write("set xlabel 'step'\n")
        f.write("set ylabel 'Total Energy (eV)'\n")
        f.write("plot[:][:] \\\n")
        for j in range(len(step[i])):
            f.write("    \"scstep.dat\" using ($1=="+str(i+1)+" && $2=="+str(j+1)+"? $4:1/0):5 title 'sc "+str(j+1)+"' with linespoints "+str(j+1))
            if j < len(step[i])-1:
                f.write(", \\")
            f.write("\n")
        f.write("pause -1\n")
    f.close()

def caldata():
    print("[caldata]")
    doc = ElementTree.parse("calculations.xml")
    root = doc.getroot()

    f = open("calculations.txt","w")

    matid = None
    chemform = None
    crysys = None
    spg = None
    spgno = None
    cif = None
    for e in root.findall("material"):
        for e1 in e.getchildren():
            if e1.tag == "material_id":
                matid = e1.text
            if e1.tag == "chemical_formula":
                chemform = e1.text
            if e1.tag == "crystal_system":
                crysys = e1.text
            if e1.tag == "spacegroup":
                spg = e1.text
            if e1.tag == "spacegroup_no":
                spgno = e1.text
            if e1.tag == "cif":
                cif = e1.text

    f.write("Material Information\n")
    f.write("Material ID: "+matid+"\n")
    f.write("Chemical Formula: "+chemform+"\n")
    f.write("CIF File: "+cif+"\n")
    f.write("\n")
    f.write("Crystal Structure\n")
    f.write("Crystal System: "+crysys+"\n")
    f.write("Spacegroup: "+spg+"\n")
    f.write("Spacegroup No: "+spgno+"\n")
    f.write("\n")

    ccell = []
    pcell = []
    catom = []
    patom = []
    for e0 in root.findall("structure[@name='original']"):
        for e1 in e0.findall("lattice[@type='conventional']"):
            for e2 in e1.findall("a"):
                la = e2.text
            for e2 in e1.findall("b"):
                lb = e2.text
            for e2 in e1.findall("c"):
                lc = e2.text
            for e2 in e1.findall("alpha"):
                aa = e2.text
            for e2 in e1.findall("beta"):
                ab = e2.text
            for e2 in e1.findall("gamma"):
                ac = e2.text
            for e2 in e1.findall("a1"):
                l0 = e2.text.split()
                ccell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a2"):
                l0 = e2.text.split()
                ccell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a3"):
                l0 = e2.text.split()
                ccell.append([l0[0],l0[1],l0[2]])
        for e1 in e0.findall("lattice[@type='primitive']"):
            for e2 in e1.findall("a1"):
                l0 = e2.text.split()
                pcell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a2"):
                l0 = e2.text.split()
                pcell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a3"):
                l0 = e2.text.split()
                pcell.append([l0[0],l0[1],l0[2]])
        for e1 in e0.findall("atom[@type='conventional']/i"):
            l0 = e1.attrib.get("name")
            l1 = e1.text.split()
            catom.append([l0,l1[0],l1[1],l1[2]])
        for e1 in e0.findall("atom[@type='primitive']/i"):
            l0 = e1.attrib.get("name")
            l1 = e1.text.split()
            patom.append([l0,l1[0],l1[1],l1[2]])

    f.write("Structure (Initial)\n")
    f.write("Cell Length: %12.6f  %12.6f  %12.6f\n" % (float(la),float(lb),float(lc)))
    f.write("Cell Angle: %12.6f  %12.6f  %12.6f\n" % (float(aa),float(ab),float(ac)))
    f.write("Conventional Cell:\n")
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(ccell[0][0]),float(ccell[0][1]),float(ccell[0][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(ccell[1][0]),float(ccell[1][1]),float(ccell[1][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(ccell[2][0]),float(ccell[2][1]),float(ccell[2][2])))
    f.write("Primitive Cell:\n")
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(pcell[0][0]),float(pcell[0][1]),float(pcell[0][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(pcell[1][0]),float(pcell[1][1]),float(pcell[1][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(pcell[2][0]),float(pcell[2][1]),float(pcell[2][2])))
    f.write("Atom:\n")
    for a in patom:
        f.write("%s %12.6f  %12.6f  %12.6f\n" % (a[0],float(a[1]),float(a[2]),float(a[3])))
    f.write("\n")

    ccell = []
    pcell = []
    catom = []
    patom = []
    for e0 in root.findall("structure[@name='relaxed']"):
        for e1 in e0.findall("lattice[@type='conventional']"):
            for e2 in e1.findall("a"):
                la = e2.text
            for e2 in e1.findall("b"):
                lb = e2.text
            for e2 in e1.findall("c"):
                lc = e2.text
            for e2 in e1.findall("alpha"):
                aa = e2.text
            for e2 in e1.findall("beta"):
                ab = e2.text
            for e2 in e1.findall("gamma"):
                ac = e2.text
            for e2 in e1.findall("a1"):
                l0 = e2.text.split()
                ccell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a2"):
                l0 = e2.text.split()
                ccell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a3"):
                l0 = e2.text.split()
                ccell.append([l0[0],l0[1],l0[2]])
        for e1 in e0.findall("lattice[@type='primitive']"):
            for e2 in e1.findall("a1"):
                l0 = e2.text.split()
                pcell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a2"):
                l0 = e2.text.split()
                pcell.append([l0[0],l0[1],l0[2]])
            for e2 in e1.findall("a3"):
                l0 = e2.text.split()
                pcell.append([l0[0],l0[1],l0[2]])
        for e1 in e0.findall("atom[@type='conventional']/i"):
            l0 = e1.attrib.get("name")
            l1 = e1.text.split()
            catom.append([l0,l1[0],l1[1],l1[2]])
        for e1 in e0.findall("atom[@type='primitive']/i"):
            l0 = e1.attrib.get("name")
            l1 = e1.text.split()
            patom.append([l0,l1[0],l1[1],l1[2]])

    f.write("Structure (Relaxed)\n")
    f.write("Cell Length: %12.6f  %12.6f  %12.6f\n" % (float(la),float(lb),float(lc)))
    f.write("Cell Angle: %12.6f  %12.6f  %12.6f\n" % (float(aa),float(ab),float(ac)))
    f.write("Conventional Cell:\n")
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(ccell[0][0]),float(ccell[0][1]),float(ccell[0][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(ccell[1][0]),float(ccell[1][1]),float(ccell[1][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(ccell[2][0]),float(ccell[2][1]),float(ccell[2][2])))
    f.write("Primitive Cell:\n")
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(pcell[0][0]),float(pcell[0][1]),float(pcell[0][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(pcell[1][0]),float(pcell[1][1]),float(pcell[1][2])))
    f.write("%12.6f  %12.6f  %12.6f\n" % (float(pcell[2][0]),float(pcell[2][1]),float(pcell[2][2])))
    f.write("Atom:\n")
    for a in patom:
        f.write("%s %12.6f  %12.6f  %12.6f\n" % (a[0],float(a[1]),float(a[2]),float(a[3])))
    f.write("\n")
                       
    etotal = None
    etotal_atom = None
    efermi = None
    efermi2 = None
    bandgap_type = None
    bandgap = None

    for e0 in root.findall("calculation"):
        if e0.attrib.get("name") == "scf":
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "etotal":
                    etotal = e1.text
                if e1.attrib.get("name") == "etotal_per_atom":
                    etotal_atom = e1.text
                if e1.attrib.get("name") == "efermi":
                    efermi = e1.text
        if e0.attrib.get("name") == "dos" or e.attrib.get("name") == "nscf":
            for e1 in e0.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi2 = e1.text
                if e1.attrib.get("name") == "bandgap_type":
                    bandgap_type = e1.text
                if e1.attrib.get("name") == "bandgap":
                    bandgap = e1.text
                            
    f.write("Electronic Structure\n\n")
    f.write("Energy\n")
    f.write("Total Energy (eV): "+etotal+"\n")
    f.write("Total Energy (eV/atom): "+etotal_atom+"\n")
    f.write("Fermi Energy (eV): "+efermi+"\n")
    f.write("Fermi Energy (DOS) (eV): "+str(efermi2)+"\n")
    f.write("\n")

    f.write("Electronic Property\n")
    f.write("Bandgap Type: "+str(bandgap_type)+"\n")
    f.write("Bandgap (eV): ")
    if bandgap and float(bandgap)>0.0:
        f.write(bandgap)
    f.write("\n")
    f.write("\n")

    f.close()

def caldata2(f):
    doc = ElementTree.parse(f)
    root = doc.getroot()

    v = []
    matid = None
    chemform = None
    crysys = None
    spg = None
    spgno = None
    cif = None
    for e in root.findall("material"):
        for e1 in e.getchildren():
            if e1.tag == "material_id":
                matid = e1.text
            if e1.tag == "chemical_formula":
                chemform = e1.text
            if e1.tag == "crystal_system":
                crysys = e1.text
            if e1.tag == "spacegroup":
                spg = e1.text
            if e1.tag == "spacegroup_no":
                spgno = e1.text
            if e1.tag == "cif":
                cif = e1.text

    v.append(matid)
    v.append(chemform)
    v.append(crysys)
    v.append(spg)
    v.append(spgno)

    ccell = []
    pcell = []
    atom = []
    for e in root.findall("structure"):
        if e.attrib.get("name") == "original":
            for e1 in e.findall("lattice"):
                if e1.attrib.get("type") == "conventional":
                    for e2 in e1.findall("a"):
                        la = e2.text
                    for e2 in e1.findall("b"):
                        lb = e2.text
                    for e2 in e1.findall("c"):
                        lc = e2.text
                    for e2 in e1.findall("alpha"):
                        aa = e2.text
                    for e2 in e1.findall("beta"):
                        ab = e2.text
                    for e2 in e1.findall("gamma"):
                        ac = e2.text
                    for e2 in e1.findall("a1"):
                        l0 = e2.text.split()
                        ccell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a2"):
                        l0 = e2.text.split()
                        ccell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a3"):
                        l0 = e2.text.split()
                        ccell.append([l0[0],l0[1],l0[2]])
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("a1"):
                        l0 = e2.text.split()
                        pcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a2"):
                        l0 = e2.text.split()
                        pcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a3"):
                        l0 = e2.text.split()
                        pcell.append([l0[0],l0[1],l0[2]])
            for e1 in e.findall("atom[@type='primitive']/i"):
                l0 = e1.attrib.get("name")
                l1 = e1.text.split()
                atom.append([l0,l1[0],l1[1],l1[2]])

    ele = []
    for a in atom:
        if a[0] not in ele:
            ele.append(a[0])
    nele = len(ele)
    natom = len(atom)

    v.append(nele)
    v.append(natom)    

    v.append(la)
    v.append(lb)
    v.append(lc)
    v.append(aa)
    v.append(ab)
    v.append(ac)

    ccell = []
    pcell = []
    atom = []
    for e in root.findall("structure"):
        if e.attrib.get("name") == "relaxed":
            for e1 in e.findall("lattice"):
                if e1.attrib.get("type") == "conventional":
                    for e2 in e1.findall("a"):
                        la = e2.text
                    for e2 in e1.findall("b"):
                        lb = e2.text
                    for e2 in e1.findall("c"):
                        lc = e2.text
                    for e2 in e1.findall("alpha"):
                        aa = e2.text
                    for e2 in e1.findall("beta"):
                        ab = e2.text
                    for e2 in e1.findall("gamma"):
                        ac = e2.text
                    for e2 in e1.findall("a1"):
                        l0 = e2.text.split()
                        ccell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a2"):
                        l0 = e2.text.split()
                        ccell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a3"):
                        l0 = e2.text.split()
                        ccell.append([l0[0],l0[1],l0[2]])
                if e1.attrib.get("type") == "primitive":
                    for e2 in e1.findall("a1"):
                        l0 = e2.text.split()
                        pcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a2"):
                        l0 = e2.text.split()
                        pcell.append([l0[0],l0[1],l0[2]])
                    for e2 in e1.findall("a3"):
                        l0 = e2.text.split()
                        pcell.append([l0[0],l0[1],l0[2]])
            for e1 in e.findall("atom/i"):
                l0 = e1.attrib.get("name")
                l1 = e1.text.split()
                atom.append([l0,l1[0],l1[1],l1[2]])

    v.append(la)
    v.append(lb)
    v.append(lc)
    v.append(aa)
    v.append(ab)
    v.append(ac)

    etotal = None
    etotal_atom = None
    efermi = None
    efermi2 = None
    bandgap_type = None
    bandgap = None
    for e in root.findall("calculation"):
        if e.attrib.get("name") == "scf":
            for e1 in e.findall("properties/i"):
                if e1.attrib.get("name") == "etotal":
                    etotal = e1.text
                if e1.attrib.get("name") == "etotal_per_atom":
                    etotal_atom = e1.text
                if e1.attrib.get("name") == "efermi":
                    efermi = e1.text
        if e.attrib.get("name") == "dos" or e.attrib.get("name") == "nscf":
            for e1 in e.findall("properties/i"):
                if e1.attrib.get("name") == "efermi":
                    efermi2 = e1.text
                if e1.attrib.get("name") == "bandgap_type":
                    bandgap_type = e1.text
                if e1.attrib.get("name") == "bandgap":
                    bandgap = e1.text
                    
    v.append(etotal_atom)
    v.append(efermi)
    v.append(bandgap_type)
    if bandgap and float(bandgap)<=0.0:
        bandgap = None
    v.append(bandgap)

    return v

if __name__ == "__main__":
    #cellparameter()
    #bandgap()
    # temporary
    #os.system("xmllint --format calculations.xml > tmp1.xml")

    dosplot()
    pdosplot()
    bandplot()
    scplot()
    caldata()

    effectivemass()
    fermisurf()
