import os
#import ConfigParser
import configparser

cfgdir = str(os.path.dirname(__file__))+"/../../config"

def read_toast_config(program, fname = None):
    '''read main toast config file
       program: program name
       fname: filename (defualt is "toast.cfg") 
    '''
    if fname is None:
        fname = os.path.join(cfgdir, "toast.cfg")
    if not os.path.isfile(fname):
        sys.stderr.write("Error can not find {}".format(fname))
        exit(1)
    #toast_cfg = ConfigParser.SafeConfigParser()
    toast_cfg = configparser.SafeConfigParser()
    toast_cfg.read(fname)

    program_options = {}
    job_options = {}
    if toast_cfg.has_section(program):
        program_options.update(toast_cfg.items(program))
    if toast_cfg.has_section("job"):
        job_options.update(toast_cfg.items("job"))
    return program_options, job_options
