import os
import collections
#import ConfigParser
import configparser
#import commands
import subprocess
from string import Template
import re

class Job():
    jobmanage_type = "interactive"
    maxjob = 0

    def __init__(self):

        self.cfgdir = str(os.path.dirname(__file__))+"/../../config"
        toast_cfg_file = os.path.join(self.cfgdir, "toast.cfg")
        if not os.path.isfile(toast_cfg_file):
            sys.stderr.write("Error can not find {}".format(toast_cfg_file))
            exit(1)
        #toast_cfg = ConfigParser.SafeConfigParser()
        toast_cfg = configparser.SafeConfigParser()
        toast_cfg.read(toast_cfg_file)
        if toast_cfg.has_option("job", "jobmanage_type"):
            self.jobmanage_type = toast_cfg.get("job", "jobmanage_type")
        else:
            self.jobmanage_type = "interactive"
        print("jobmanage_type: ",self.jobmanage_type)

        self.para = {}
        #self.jobid = collections.OrderedDict()
        #self.jobstat = collections.OrderedDict()

        f = self.cfgdir+"/jobmanage.cfg"
        self.read_config(f)

    def read_config(self,f):
        #doc = ConfigParser.SafeConfigParser(allow_no_value=True)
        doc = configparser.SafeConfigParser(allow_no_value=True)
        doc.read(f)
        inp = collections.OrderedDict()
        for s in doc.sections():
            for k in doc.options(s):
                v = doc.get(s,k)
                inp[k] = doc.get(s,k)
            self.para[s] = collections.OrderedDict()
            self.para[s] = inp.copy()

        #self.submit = self.para[self.jobmanage_type]["submit"]
        #self.stat = self.para[self.jobmanage_type]["stat"]
        self.cfgdata = self.para[self.jobmanage_type]
        self.submit = self.cfgdata["submit"]
        self.stat = self.cfgdata["stat"]
        self.maxjob = int(self.cfgdata.get("maxjob",0))

    def jobscript(self, cmdline, matid, np):
        # if self.jobmanage_type == "interactive":
        #     self.jobscript_interactive(cmdline, matid, np)
        # else:
        #     self.jobscript_template(cmdline, matid, np)
        self.jobscript_template(cmdline, matid, np)

    def jobscript_interactive(self, cmdline, matid,np):
        jobname = matid
        f = open("job.sh","w")
        f.write("#!/bin/csh\n")
        f.write("echo $$\n")
        f.write("\n")
        f.write(cmdline+"\n")
        f.write("\n")
        f.close()

    def jobscript_template(self, cmdline, matid, nproc):
        #name = self.jobmanage_type
        #np = self.para[name]["np"]
        np = self.cfgdata.get("np", 1)
        # jobname = matid
        #cfgdata = self.para[name].copy()
        cfgdata = self.cfgdata.copy()
        tmpl = cfgdata["template"]
        if "job_name" not in cfgdata or len(cfgdata["job_name"].strip()) == 0:
            cfgdata["job_name"] = matid
        print("jobname:",cfgdata["job_name"])

        cfgdata["np"] =  str(nproc)
        fullpath = os.path.join(self.cfgdir, tmpl)
        script = open(fullpath, "r").read()
        s = Template(script)
        f = open("job.sh", "w")
        f.write(s.substitute(cfgdata))
        f.write("\n")
        f.write(cmdline+"\n")
        f.write("\n")
        f.close()
        
    def jobsubmit(self,matid):
        cmd = self.submit+" job.sh"
        #r = commands.getoutput(cmd)
        r = subprocess.getoutput(cmd)
        r0 = r.split("\n")
        jobid = r0[0]
        #print(jobid)

        if "jobid_regexp" in self.cfgdata:
            match = re.search(self.cfgdata["jobid_regexp"], jobid)
            if match:
                jobid = match.group(1)

        #self.jobid[matid] = jobid
        return jobid

def jobstat():
    job = Job()

    fjob = open("joblist.txt")
    jobs0 = collections.OrderedDict()
    for l in fjob:        
        l0 = l.split()
        jobid = l0[2]
        jobs0[jobid] = l0
    fjob.close()
    #print(jobs0)

    cmd = job.stat
    #ret = commands.getoutput(cmd)
    ret = subprocess.getoutput(cmd)
    #print(ret)
    l0 = ret.split('\n')
    jobs1 = collections.OrderedDict()
    qtype = "pbs"
    for i,l in enumerate(l0):
        if i==0:
            #l1 = l.split()
            #print(l1)
            if "Job id" in l:
                qtype = "pbs"
            elif "job-ID" in l:
                qtype = "ge"
        elif i==1:
            continue
        else:
            l1 = l.split()
            jobid = l1[0]
            #print(l1)
            jobs1[jobid] = l1
    #print(jobs1)

    fjob = open("jobstat.txt","w")
    print("[jobs status (qstat)]")
    #for k,v in jobs0.iteritems():
    for k,v in jobs0.items():
        if k in jobs1:
            # pbs
            #jobs0[k][1] = jobs1[k][4]
            #jobs0[k].extend([jobs1[k][3],jobs1[k][5]])
            if qtype == "pbs": # pbs
                jobs0[k][1] = jobs1[k][4]
                jobs0[k].extend([jobs1[k][3],jobs1[k][5]])
            elif qtype == "ge": # grid engine
                q = jobs1[k][4].upper()
                jobs0[k][1] = q
                if q == "QW":
                    jobs0[k][1] = "Q"
                jobs0[k].extend([jobs1[k][5],jobs1[k][6],jobs1[k][7]])
        else:
            #jobs0[k][1] = "F"
            jobs0[k][1] = "-"
        for x in jobs0[k]:
            fjob.write(str(x)+" ")
            #print(x,)
            print(x,"",end="")
        fjob.write("\n")
        #print
        print()
    fjob.close()
    return jobs0

def parse_args(cmd, d):
    """substitute $[a-zA-Z]+ in cmd using dictionary d

    For example, $nk will be substituted with d["_arg_nk"]
    """
    def replace_args(matchobj):
        s = matchobj.group(0)
        word = s[1:]
        key = "_arg_" + word
        if key in d:
            return d[key]
        else:
            print(key,"not found")
        return s
    newcmd, count = re.subn("\$[_a-zZ-Z]+", replace_args, cmd)
    return newcmd

def jobsh(cmd, mpicmd, np, calcoption):
    f1 = calcoption.get("_input_file", "job.in")
    f2 = calcoption.get("_script_file", "job.sh")
    #print("input_file",f1,"script_file",f2)
    f = open(f2,"w")
    if "$" in cmd:
        #print("cmd=",cmd)
        cmd = parse_args(cmd, calcoption)
    if os.path.isfile(f1):
        f.write("%s %s %s < %s\n" % (mpicmd, np, cmd, f1))
    else:
        f.write("%s %s %s\n" % (mpicmd, np, cmd))
    f.close()
